# community.docker.docker_login module – Log into a Docker registry.

Note

This module is part of the community.docker collection (version 3.4.5).

To install it, use: `ansible-galaxy collection install community.docker`. You need further requirements to be able to use this module, see Requirements for details.

To use it in a playbook, specify: `community.docker.docker_login`.

## Synopsis

- Provides functionality similar to the `docker login` command.

- Authenticate with a docker registry and add the credentials to your local Docker config file respectively the credentials store associated to the registry. Adding the credentials to the config files resp. the credential store allows future connections to the registry using tools such as Ansible’s Docker modules, the Docker CLI and Docker SDK for Python without needing to provide credentials.

- Running in check mode will perform the authentication without updating the config file.

## Requirements

The below requirements are needed on the host that executes this module.

- Docker API >= 1.25

- backports.ssl_match_hostname (when using TLS on Python 2)

- paramiko (when using SSH with use_ssh_client=false)

- pyOpenSSL (when using TLS)

- pywin32 (when using named pipes on Windows 32)

- requests

## Parameters

Parameter | Comments
--- | ---

api_version

aliases: docker_api_version

string

The version of the Docker API running on the Docker Host.

Defaults to the latest version of the API supported by this collection and the docker daemon.

If the value is not specified in the task, the value of environment variable `DOCKER_API_VERSION` will be used instead. If the environment variable is not set, the default value will be used.

Default: `"auto"`

ca_cert aliases: tls_ca_cert, cacert_path path | Use a CA certificate when performing server verification by providing the path to a CA certificate file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `ca.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used.
client_cert aliases: tls_client_cert, cert_path path | Path to the client’s TLS certificate file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `cert.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used.
client_key aliases: tls_client_key, key_path path | Path to the client’s TLS key file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `key.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used.
config_path aliases: dockercfg_path path | Custom path to the Docker CLI configuration file. Default: `"~/.docker/config.json"`

debug

boolean

Debug mode

Choices:

- `false` ← (default)

- `true`

docker_host

aliases: docker_url

string

The URL or Unix socket path used to connect to the Docker API. To connect to a remote host, provide the TCP connection string. For example, `tcp://192.0.2.23:2376`. If TLS is used to encrypt the connection, the module will automatically replace `tcp` in the connection URL with `https`.

If the value is not specified in the task, the value of environment variable `DOCKER_HOST` will be used instead. If the environment variable is not set, the default value will be used.

Default: `"unix://var/run/docker.sock"`

password string | The plaintext password for the registry account. Required when state is `present`.

reauthorize

aliases: reauth

boolean

Refresh existing authentication found in the configuration file.

Choices:

- `false` ← (default)

- `true`

registry_url aliases: registry, url string | The registry URL. Default: `"https://index.docker.io/v1/"`
ssl_version string | Provide a valid SSL version number. Default value determined by ssl.py module. If the value is not specified in the task, the value of environment variable `DOCKER_SSL_VERSION` will be used instead.

state

string

This controls the current state of the user. `present` will login in a user, `absent` will log them out.

To logout you only need the registry server, which defaults to DockerHub.

Before 2.1 you could ONLY log in.

Docker does not support ‘logout’ with a custom config file.

Choices:

- `"present"` ← (default)

- `"absent"`

timeout integer | The maximum amount of time in seconds to wait on a response from the API. If the value is not specified in the task, the value of environment variable `DOCKER_TIMEOUT` will be used instead. If the environment variable is not set, the default value will be used. Default: `60`

tls

boolean

Secure the connection to the API by using TLS without verifying the authenticity of the Docker host server. Note that if validate_certs is set to `true` as well, it will take precedence.

If the value is not specified in the task, the value of environment variable `DOCKER_TLS` will be used instead. If the environment variable is not set, the default value will be used.

Choices:

- `false` ← (default)

- `true`

tls_hostname

string

When verifying the authenticity of the Docker Host server, provide the expected name of the server.

If the value is not specified in the task, the value of environment variable `DOCKER_TLS_HOSTNAME` will be used instead. If the environment variable is not set, the default value will be used.

Note that this option had a default value `localhost` in older versions. It was removed in community.docker 3.0.0.

use_ssh_client

boolean

added in community.docker 1.5.0

For SSH transports, use the `ssh` CLI tool instead of paramiko.

Choices:

- `false` ← (default)

- `true`

username string | The username for the registry account. Required when state is `present`.

validate_certs

aliases: tls_verify

boolean

Secure the connection to the API by using TLS and verifying the authenticity of the Docker host server.

If the value is not specified in the task, the value of environment variable `DOCKER_TLS_VERIFY` will be used instead. If the environment variable is not set, the default value will be used.

Choices:

- `false` ← (default)

- `true`

## Attributes

Attribute | Support | Description
--- | --- | ---
action_group | Action groups: community.docker.docker, docker | Use `group/docker` or `group/community.docker.docker` in `module_defaults` to set defaults for this module.
check_mode | Support: full | Can run in `check_mode` and return changed status prediction without modifying target.
diff_mode | Support: none | Will return details on what has changed (or possibly needs changing in `check_mode`), when in diff mode.

## Notes

Note

- Connect to the Docker daemon by providing parameters with each task or by defining environment variables. You can define `DOCKER_HOST`, `DOCKER_TLS_HOSTNAME`, `DOCKER_API_VERSION`, `DOCKER_CERT_PATH`, `DOCKER_SSL_VERSION`, `DOCKER_TLS`, `DOCKER_TLS_VERIFY` and `DOCKER_TIMEOUT`. If you are using docker machine, run the script shipped with the product that sets up the environment. It will set these variables for you. See https://docs.docker.com/machine/reference/env/ for more details.

- This module does not use the Docker SDK for Python to communicate with the Docker daemon. It uses code derived from the Docker SDK or Python that is included in this collection.

## Examples

    - name: Log into DockerHub
      community.docker.docker_login:
        username: docker
        password: rekcod

    - name: Log into private registry and force re-authorization
      community.docker.docker_login:
        registry_url: your.private.registry.io
        username: yourself
        password: secrets3
        reauthorize: true

    - name: Log into DockerHub using a custom config file
      community.docker.docker_login:
        username: docker
        password: rekcod
        config_path: /tmp/.mydockercfg

    - name: Log out of DockerHub
      community.docker.docker_login:
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Description
--- | ---
login_results dictionary | Results from the login. Returned: when state=present Sample: `{"serveraddress": "localhost:5000", "username": "testuser"}`

### Authors

- Olaf Kilian (@olsaki)

- Chris Houseknecht (@chouseknecht)

### Collection links

Issue Tracker Repository (Sources) Submit a bug report Request a feature Communication